/*
 * Copyright (C) 2019  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#pragma once

#include <stdint.h>

#include "Bsp/SystemTime.h"
#include "Bsp/ReturnCode.h"
#include "Bsp/Time.h"

#include "stm32l0xx.h"

namespace BSP {

class RtcDriver final {
public:

    RtcDriver() = delete;
    ~RtcDriver() = delete;

    static SystemTimerImpl& get_system_timer() {
        return m_sys_timer;
    };
    static BSP::ReturnCode init();
    static void increment_seconds();
    static BSP::ReturnCode get_time(BSP::WallClockTime &tm_bcd);
    static BSP::ReturnCode set_time(const BSP::WallClockTime &tm_bcd);
    static BSP::ReturnCode set_wakeup_in(BSP::time_t wakeup_delay);

private:

    static BSP::ReturnCode init_hw();
    static void enable_rtc_write();
    static void disable_rtc_write();
    static void enable_rtc_wakeup_interrupt();
    static void enable_periodic_alarm();

    static constexpr uint32_t LSE_CLOCK_FREQ = 32768;

    static RTC_TypeDef *m_rtc;

    class RtcSystemTimer : public BSP::SystemTimerImpl {
    public:

        RtcSystemTimer()
            : m_seconds(0)
        {}

        ~RtcSystemTimer() {}

        BSP::time_t get_time() override;
        void increment_seconds();

    private:
        /** ~136 years. Good enough for me. */
        uint32_t m_seconds;

        static constexpr uint32_t LSE_CLOCK_FREQ = 32768;
    };

    static RtcSystemTimer m_sys_timer;
};

}
